#!/usr/bin/env bash

##--------------------------------------------------------------------
## Copyright (c) 2021 Dianomic Systems Inc.
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##--------------------------------------------------------------------

##
## Author: Amandeep Singh Arora
##

# PCA is no longer used for the autoencoder based anomaly model

# Combine chunks of ae_kernel_PCA_64.dat file that has been split because of Github file size limit of 50 MB
# Also check whether  is required for this file operation
# model_dir=$(dpkg -S foglamp | grep 'python/foglamp/plugins/filter/ADM_LD_prediction/model$' | awk '{print $2}')
# ls -lrtd ${model_dir} | awk '{print $3}' | grep -qw root
# _reqd=$?
# cd ${model_dir}
# [ $_reqd -eq 0 ] && cmd_prefix="sudo" || cmd_prefix=""
# cmd="$cmd_prefix cat ae_kernel_PCA_64.dat.?? > ae_kernel_PCA_64.dat"
# eval ${cmd}
# cd - > /dev/null

set -e

# Install tflite_runtime from https://www.tensorflow.org/lite/guide/python
py=$(python3 -V | awk '{print $2}' | awk -F. '{print $1 $2}')
arch=$(uname -m)
url=$(echo -n "https://github.com/google-coral/pycoral/releases/download/v2.0.0/tflite_runtime-2.5.0.post1-cp${py}-cp${py}m-linux_${arch}.whl")

# check if URL needs to be updated to the newer format without the 'm', i.e. '-cp38m-linux' to '-cp38-linux'
if ! wget -q --method=HEAD ${url};
 then
  url=$(echo -n "https://github.com/google-coral/pycoral/releases/download/v2.0.0/tflite_runtime-2.5.0.post1-cp${py}-cp${py}-linux_${arch}.whl")
fi

python3 -m pip install $url

ID=$(cat /etc/os-release | grep ^ID= | cut -d'=' -f2)

if [ ${ID} != "mendel" ]; then
  echo "In order to use Edge TPU, please install edge TPU runtime, libedgetpu1-std
https://coral.ai/software/#debian-packages
note: This is pre-installed on Coral Dev Board."
fi

